#!/usr/bin/python3

from simple_salesforce import Salesforce, SFType, SalesforceLogin
import urllib.request
import pandas as pd
import random
import time

def verwijder(SessionId,ServerURL):
    url=ServerURL+'/async/48.0/job' 
    print(url)
    data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\jobQuerySales.txt')
    headers = {'X-SFDC-Session': SessionId,
               'Content-Type': 'application/xml; charset=UTF-8'
    }
    req = urllib.request.Request(url, data, headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        result1=x.find('<id>')
        if result1!=-1:
            result2=x.find('</id>',result1+1)
            JobID = x[result1+4:result2]
            print('JobID=  ',JobID)
    f.close()
    url1=ServerURL+'/async/48.0/job/'+JobID+'/batch' 
    print(url1)
    data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\queryTxtSalesBak.txt').read()
    #print(type(data))
    #data=urllib.parse.urlencode(data)
    data=data.encode('utf-8')
    headers = {'X-SFDC-Session': SessionId,
               'Content-Type': 'text/csv; charset=UTF-8'
    }
    #print(data)
    req = urllib.request.Request(url1, data, headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        result1=x.find('<id>')
        if result1!=-1:
            result2=x.find('</id>',result1+1)
            BatchID = x[result1+4:result2]
            print('BatchID=  ',BatchID)
    url2=ServerURL+'/async/48.0/job/'+JobID+'/batch/'+BatchID
    print(url2)
    headers = {
        'X-SFDC-Session': SessionId,
    }
    req = urllib.request.Request(url2,headers= headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        print(x)
        result1=x.find('<state>')
        if result1!=-1:
            result2=x.find('</state>',result1+1)
            State = x[result1+7:result2]
            print('State=  ',State)

    url3=ServerURL+'/async/48.0/job/'+JobID+'/batch/'+BatchID+'/result'
    print(url3)


    headers = {
        'X-SFDC-Session': SessionId,
    }
    req = urllib.request.Request(url3,headers= headers)
    result1=-1
    while result1==-1:
        time.sleep(2)
        print('--ff w88-----')
        f = urllib.request.urlopen(req)
        for x in f:
            x=str(x)
            print(x)
            result1=x.find('<result>')
            if result1!=-1:
                result2=x.find('</result>',result1+1)
        #        print(result1,'- ',result2)
                resultZoek = x[result1+8:result2]
        #        print('result=  ',resultZoek)


    url4=ServerURL+'/async/48.0/job/'+JobID+'/batch/'+BatchID+'/result/'+resultZoek
    print(url4)

    f1= open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\deleteFileSales.txt','w', encoding='utf-8')
    headers = {
        'X-SFDC-Session': SessionId,
    }
    req = urllib.request.Request(url4,headers= headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)[3:len(x)]
        f1.write(x + '\n')
    #    print(x)
    f1.close()


    #--------------DELETE-------------------


    url=ServerURL+'/async/48.0/job' 
    print(url)
    data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\jobDeleteSales.txt')
    headers = {'X-SFDC-Session': SessionId,
               'Content-Type': 'application/xml; charset=UTF-8'
    }
    req = urllib.request.Request(url, data, headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        result1=x.find('<id>')
        if result1!=-1:
            result2=x.find('</id>',result1+1)
            JobID = x[result1+4:result2]
    #        print('JobID=  ',JobID)
    f.close()
    url=ServerURL+'/async/48.0/job/'+JobID+'/batch' 
    print(url)
    data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\deleteFileSales.txt').read()
    #print(type(data))
    #data=urllib.parse.urlencode(data)
    data=data.encode('utf-8')
    headers = {'X-SFDC-Session': SessionId,
               'Content-Type': 'text/csv; charset=UTF-8'
    }
    #print(data)
    req = urllib.request.Request(url, data, headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        result1=x.find('<id>')
        if result1!=-1:
            result2=x.find('</id>',result1+1)
            BatchID = x[result1+4:result2]
    #        print('BatchID=  ',BatchID)
    url=ServerURL+'/async/48.0/job/'+JobID+'/batch/'+BatchID
    print(url)
    headers = {
        'X-SFDC-Session': SessionId,
    }
    req = urllib.request.Request(url,headers= headers)
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        result1=x.find('<state>')
        if result1!=-1:
            result2=x.find('</state>',result1+1)
            State = x[result1+7:result2]
            print('State=  ',State)

    #print('--------------')

    url=ServerURL+'/async/48.0/job/'+JobID
    print(url)
    data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\close_job.txt')
    headers = {
        'X-SFDC-Session': SessionId,
        'Content-Type': 'application/xml; charset=UTF-8',
    }
    req = urllib.request.Request(url, data, headers)
    f = urllib.request.urlopen(req)





def verwijder10000(doeeenrondje, SessionId,ServerURL):
    print('doeeenrondje : ',doeeenrondje)
    sf = Salesforce(username='datamigrationuser@pension4you.nl.pensiond2', password='EEee11!!', security_token='povRgwi6F3nqrOxyHNGp1KanI',domain='test')
    stmt = 'select count() from SalesForceBak__c'
    sf_data = sf.query_all(stmt)
    nmbrRowsStart = sf_data['totalSize']
    print('Number of rows in SalesForceBak__c ', nmbrRowsStart)

    verwijder(SessionId,ServerURL)

    gadoor = 0
    while gadoor == 0:
        print('nog ff w88---')
        time.sleep(20)
        sf = Salesforce(username='datamigrationuser@pension4you.nl.pensiond2', password='EEee11!!', security_token='povRgwi6F3nqrOxyHNGp1KanI',domain='test')
        stmt = 'select count() from SalesForceBak__c'
        sf_data = sf.query_all(stmt)
        nmbrRowsEind = sf_data['totalSize']
        print('Number of rows in SalesForceBak__c -nmbrRowsEind- ', nmbrRowsEind)
        verschil = nmbrRowsStart - nmbrRowsEind
        print(' aantal records verwijder -verschil - ',verschil)
        if nmbrRowsEind==0: 
            doeeenrondje = 1
        if verschil == 10000 or doeeenrondje == 1:
            gadoor = 1
    return doeeenrondje
            
headers = {
    'Content-Type': 'text/xml; charset=UTF-8',
    'SOAPAction': 'login',
}
    
data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\login.txt')
url = 'https://test.salesforce.com/services/Soap/u/48.0'
req = urllib.request.Request(url, data, headers)
f = urllib.request.urlopen(req)
for x in f:
    x=str(x)
    result1 = x.find('serverUrl')
    result2 = x.find('serverUrl',result1+1)
    vollServerURL = x[ result1+10 : result2-2]
    einde=vollServerURL.find('Soap')
    ServerURL=vollServerURL[0:einde-1]
    print('ServerURL= ',ServerURL)
    result1 = x.find('sessionId')
    result2 = x.find('sessionId',result1+1)
    SessionId = x[ result1+10 : result2-2]
    print('SessionID= ',SessionId)
f.close()

doeeenrondje = 0
teller = 1
while doeeenrondje == 0:
    doeeenrondje = verwijder10000(doeeenrondje, SessionId,ServerURL)
    print('doeeenrondje=  ',doeeenrondje)
    teller = teller + 1
    if teller > 200:
        doeeenrondje = 1

