import json 
import csv 
import urllib.request
import xml.etree.ElementTree as ET
import pandas as pd
import time

from shutil import copyfile



headers = {
    'Content-Type': 'text/xml; charset=UTF-8',
    'SOAPAction': 'login'
}
data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\login.txt')
url = 'https://test.salesforce.com/services/Soap/u/48.0'
req = urllib.request.Request(url, data, headers)
f = urllib.request.urlopen(req)
for x in f:
    tree = ET.fromstring(x)
    for child in tree:
        for child in child:
            for child in child:
                for child in child:
                    hx=str(child.tag)
                    result = hx.find('sessionId')
                    if result != -1:
                        sessionId=child.text
                    result = hx.find('serverUrl')
                    if result != -1:
                        serverUrl=child.text
                        einde=serverUrl.find('Soap')
                        serverUrl=serverUrl[0:einde-1]
                        urlNmbrCall = serverUrl+'/data/v48.0/limits'
                        serverUrl=serverUrl+'/async/48.0/job/'
print('SessionId:  ',sessionId)
print('ServerURL:  ',serverUrl)
print('urlNmbrCall ',urlNmbrCall)
f.close()

stmt = "Bearer "+sessionId 
headers = {
    'Authorization': stmt,
     'X-PrettyPrint': '1',
}
req = urllib.request.Request(urlNmbrCall,headers= headers)
f = urllib.request.urlopen(req)
laatzien=-1
vrij=-1
for x in f:
    x=str(x)
#    print(x)
    result1 = x.find('DailyBulkApiRequests')
    if result1!=-1:
        laatzien=0
    if laatzien in [0,1,2]:           
        print(x)
        laatzien=laatzien+1

data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\jobSales.txt')
headers = {'X-SFDC-Session': sessionId,
           'Content-Type': 'application/json; charset=UTF-8',
           'Accept': 'application/json'
}
req = urllib.request.Request(serverUrl, data, headers)
f = urllib.request.urlopen(req)
for x in f:
    a_json = json.loads(x)
    df = pd.DataFrame.from_dict(a_json, orient="index")
    JobID = df.loc['id'][0]
    print('JobID=',JobID)
f.close()
url=serverUrl+JobID+'/batch' 
print('ServerURL= ',url)

data = open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\queryTxtSales.txt').read()
data=data.encode('utf-8')
headers = {'X-SFDC-Session': sessionId,
           'Content-Type': 'text/csv; charset=UTF-8'
}
#print(data)
req = urllib.request.Request(url, data, headers)
f = urllib.request.urlopen(req)
for x in f:
    x=str(x)
#    print(x)
    result1=x.find('<id>')
    if result1!=-1:
        result2=x.find('</id>',result1+1)
        BatchID = x[result1+4:result2]
        print('BatchID=  ',BatchID)

url=serverUrl+JobID+'/batch/'+BatchID
print(url)
headers = {
    'X-SFDC-Session': sessionId,
}
req = urllib.request.Request(url,headers= headers)
f = urllib.request.urlopen(req)
for x in f:
    x=str(x)
    result1=x.find('<state>')
    if result1!=-1:
        result2=x.find('</state>',result1+1)
        State = x[result1+7:result2]
        print('State=  ',State)

url=serverUrl+JobID+'/batch/'+BatchID+'/result'
print(url)


headers = {
    'X-SFDC-Session': sessionId,
}
req = urllib.request.Request(url,headers= headers)
result1=-1
while result1==-1:
    time.sleep(2)
    print('--ff w88-----')
    f = urllib.request.urlopen(req)
    for x in f:
        x=str(x)
        print(x)
        result1=x.find('<result>')
        if result1!=-1:
            result2=x.find('</result>',result1+1)
            resultZoek = x[result1+8:result2]

url=serverUrl+JobID+'/batch/'+BatchID+'/result/'+resultZoek
print(url)

f1= open('C:\\Users\\tmaanen\\Documents\\CloudStation\\Pensioenfonds\\moeilijk\\uitvoerFileSales.txt','w', encoding='utf-8')
headers = {
    'X-SFDC-Session': sessionId,
}
req = urllib.request.Request(url,headers= headers)
f = urllib.request.urlopen(req)
for x in f:
    x=str(x)[2:len(x)+1]
    f1.write(x + '\n')
#    print(x)
f1.close()


